View Issue Details

IDProjectCategoryView StatusLast Update
0014006MediaMonkey 5Main Panelpublic2018-04-30 23:46
Reporterrusty 
PriorityurgentSeveritymajorReproducibilityalways
Status closedResolutionfixed 
Product Version 
Target VersionFixed in Version5.0 
Summary0014006: Customization and Tweaks re. management of in-app windows
DescriptionIssues with the current approach:
-'x's sometimes obscure Windows' UI
-it's not always clear how to re-enable a closed window
-the notion of Windows configuration is mixed with hide/unhide functionality (i.e. users can't hide the right dock--only the NP window)

Proposed short term fixes:
- use the View/checkboxes for configuration as with MM4
- For windows with a titlebar, include an 'x' (e.g. for the Now Playing Window or for the in-view Properties dialog 0013225). It's not required for any other dialog.
- For the left hand column, enable/hide via the 'menu button' (already implemented)
- For the right hand column, enable/hide via the 'NP' button in the player--currently it only applies to the NP list (or via an analogous button to the menu button to the right of the 'search' icon). Note: The icon should be changed to the inverse of the current 'menu' icon.

For the future:
1. We can implement customization/configuration UI: i.e. ability to d&d controls to various places, load&save of config, etc. (note: this would be independent of hide/unhide column functionality).

2. Leave it to custom layouts (currently named Modes in MM5), where Addon authors can implement anything (or perhaps even integrate custom addons _into_ the config UI).

Jiri indicated a preference for approach 2.

3. For hide/unhide functions, we could also switch to the lightroom / firefox all-in-one sidebar approach to add hide/unhide controls at the margins of the sidebars. Whether this makes sense depends on the amount of space that would be wasted through the use of these controls.
TagsNo tags attached.
Fixed in build2102

Relationships

related to 0013225 assignedpetr Properties dialog improvements 
related to 0014124 closedjiri Lyrics View: Lyrics View can't be closed and auto search lyrics is executed even it is disabled 
related to 0013406 closedLudek NP Art & Details dialog improvements 

Activities

michal

2017-02-14 16:05

developer   ~0047278

Last edited: 2017-02-14 16:06

View 2 revisions

Short term fixes implemented in build 2062. For NP panel used only button on player now.

jiri

2017-02-14 16:37

administrator   ~0047279

Last edited: 2017-02-17 14:04

View 6 revisions

Since the requests for customization are coming, it seems that we'll need to implement something re. item 1. First of all I was thinking about a generic configuration where user could place elements anywhere. It could be achieved by a tree-like UI describing controls from top to down or from left to right using nesting as needed. While this offers enormous flexibility and could be quite easily implemented, I don't think it's a good idea, since it poses challenges re. integration with various MM5 features and UI controls (MM needs to know when and how to show some controls, etc.).

So, imho, we should make it fixed that MM5 has left and right sidebar (and support >1 sidebar for each side later??) and let user select content of both, for example using listviews and d&d of items among them (listviews preferably side by side) in the Options dialog (which could be shown directly from View>Mode>Default [config icon]):

Left Sidebar (top to bottom): {checkboxes indicate visibility of the controls at this moment}
------------------
[x] Tree
[x] A&D

Right Sidebar (top to bottom):
------------------
[x] NP
[x] Lyrics
[ ] Custom panel 1


Available controls:
-------------------
Custom panel 2
Equalizer
etc.

Notes:
 - There's the visibility checkbox in order to be able to place a control to a particular place, but keep it hidden until a particular feature of MM needs it.
 - We could consider addition of Top and Bottom panels for configuration as well (e.g. to place Player to the bottom panel)
 - Currently we have some hidden placemarks as a part of the main layout (e.g. where to show Playlist editor). We'll probably have to hard-code this at first or seek another way of how to either make this configurable from UI (probably not too much needed?) or at least make it easily customizable in the HTML code.
 - I saw a wish to extend tree into the player area and thus making the player narrower. I guess that we could implement it as '[x] Extend sidebar to Player' options for both sidebars.
 - Each configuration could possibly be saved and later used through View>Mode menu.
 - As a part of this we probably should create some more panels available for placement (Lyrics (only, without A&D stuff), EQ, possibly a sample custom panel (for scripters).

Technical: While implementing this, we should take into account requirements of item 2) (custom layouts), so that script authors could easily reuse our code for (not only) panels placement within MM UI (which requires splitters placement, etc.).

petr

2017-03-11 21:46

developer   ~0047458

Fixed

jiri

2017-03-13 08:24

administrator   ~0047460

Last edited: 2017-03-13 08:26

View 2 revisions

Works well, just:

1. Sometimes after the change of layout splitters don't work (e.g. between NP list and A&D).

2. The listviews in Options could be a bit taller, for ~5 lines of text.

3. 'Live view' checkbox doesn't seem to be necessary, it should always present the live view.

4. View>Mode>My saved layout, then again to View>Mode and there's still the 'Default' layout selected.

petr

2017-03-21 21:54

developer   ~0047549

Items 2-4 fixed. Remaining splitter issue.

peke

2017-03-22 13:10

developer   ~0047584

5. All in-app windows should contain (x) currently Lyrics can't be closed 0014124

rusty

2017-03-23 20:10

administrator   ~0047608

6. Menu > View should have a 'Configure layout...' entry

7) Text changes:
Layouts --> Layout
Available docks --> Configure Layout
Left dock --> Left panel
Right dock --> Right panel
Available dockable controls --> Available elements
New: Drag available elements to a panel to be displayed, or to re-order them.

8) Most config panels don't have bolded text heading each subsection.

9) Stored layouts functionality is unclear. How does the user choose which layout is currently active? Which layout is being edited?

10) Main menu always visible --> Menu bar

11) Should we move some permanently configured items from the View menu to this entry? e.g.
Show:
[x] Player
[x] Main menu

12) Should we remove the following from the View menu:
Media Tree
Art & Details

jiri

2017-03-24 09:30

administrator   ~0047613

Last edited: 2017-03-24 09:35

View 3 revisions

9) I'd change it as follows:
 i) Remove up/down arrows - always sort alphabetically with Default first and <Add new layout> last.
 ii) Change it from a listview to a drop down: Edited layout: _<Default>____ [v]
    _or_ even better move the dropdown to the top as: Configure Layout: _<Default>____ [v]
 iii) Show a Delete button, when non-default layout is chosen
 iv) Remove all the buttons, as they are replaced by other functionality.

11) I'd consider this in the future, atm I'm not sure it's the best approach, let's leave the idea to mature a bit.

12) Seem to be still useful to me (as a quick way to show/hide individual controls)

13) Left and Right panel headers in the Config dialog could have checkboxes to handle their visibility (so that it can be changed right from the dialog).

14) Bug: When in Touch mode and change to a saved desktop layout, the layout is changed while still keeping in the Touch mode.

15) Restructure Mode menu as:
  Default
  Saved layout 1
  Saved layout 2
  -------------- {this separator shown only when >= 1 save layouts exist}
  Touch

petr

2017-03-25 16:38

developer   ~0047621

Fixed

jiri

2017-03-27 07:43

administrator   ~0047629

16) Per IM discussion with Petr, we should persist left and right panel visibility per tab, while layout of individual controls should be common to all tabs. This currently doesn't work well, right panel visibility is common to all tabs.

petr

2017-03-27 09:39

developer   ~0047631

Item 16 Fixed

peke

2017-03-28 23:39

developer   ~0047660

Verified 2064

rusty

2017-08-09 22:06

administrator   ~0048502

Last edited: 2017-08-11 16:48

View 2 revisions

I did some quick testing of this and found that:

1) Some items can be dragged to locations that aren't supported. e.g. Lyrics panel can be dragged to the bottom panel, but it doesn't display any lyrics!

2) Dragging panels often drags the wrong panel. e.g. drag Lyrics to Bottom Panel. Drag Lyrics from bottom panel. --> Player gets dragged instead of Lyrics!!

3) Dragging panels between locations (and accepting the new location) sometimes results in crash-errors (e.g. dragging and enabling lyrics.)

4) Dragging some dialogs (e.g. Arts and Details) from the right column to the left column and back --> it doesn't resize correctly (it redraws to half the expected width of the column).

petr

2017-09-15 16:10

developer   ~0048770

Fixed

rusty

2018-04-11 19:21

administrator   ~0049921

Tested 2095

1) 'Media Tree' can still be dragged to the 'Below tracklist' and 'Bottom' positions, even though it's not supported in those positions.

3) Dragging the A&D panel from the Right Panel to the Left Panel while tracks are playing -->
Uncaught Error: "Cannot read property 'title' of undefined' (on track transition)

(see attached).

5) a) Dragging the Player to the 'Bottom' position sometimes displays the player even when the 'Bottom' panel isn't enabled. This also occurs wit the Media Tree in the 'Left panel'.
b) Whenever the user drags an element to a panel that is disabled, MM should enable the panel so that the user can see the effect of the change (plus it's unlikely that the user wants the panel disabled if they've just dragged the element to it).

6) Possibly related to 5a, There's a bit of a disconnect between the configuration in the 'Configure layout' panel and that displayed in the Menus; If a right/left panel is disabled via the panel toggles, then the elements contained within that panel are shown as disabled in the View Menu. However, within the View Options, the elements are shown as enabled!

Related to the above: if multiple elements are enabled within a panel and the user toggles the panel to disable it, then enabling one of the disabled elements causes both elements of the panel to become enabled.

These aren't major issues, but it seems they can both be easily fixed by removing the following entries from the View menu: Media Tree, Player, Now Playing, A&D, Lyrics.

7) If the user navigates to Tools > Options > Layout it appears as if the layout is being set globally, whereas my understanding is that it's supposed to be set for the currently active tab. Perhaps the header should be changed to:
Configure layout (current tab)

8) Suggested terminology changes to better differentiate between Panels (containers) and functional windows:
a) Below tracklist --> Tracklist panel
b) Bottom --> Bottom panel
c) Art&Detail panel --> Art & Details
d) Now Playing panel --> Now Playing
e) Lyrics panel --> Lyrics

rusty

2018-04-11 19:24

administrator  

bug_14006_issue_3.jpg (124,862 bytes)
bug_14006_issue_3.jpg (124,862 bytes)

petr

2018-04-23 17:32

developer   ~0050066

Last edited: 2018-04-23 17:48

View 2 revisions

Items 1, 3, 7 & 8 are fixed

petr

2018-04-23 20:48

developer   ~0050068

Fixed

rusty

2018-04-24 20:56

administrator   ~0050102

Tested 2101--looks good. I just found a couple of additional issues:

5c) Dragging the Media Tree from the Left Panel to the Right Panel (while tracks were playing) --> Uncaught Error: "Cannot read property 'tiitle' of undefined". See attached.

9) Dragging 'Now Playing' to the left panel and then to the right panel and then to Available Elements and back to the right panel
--> the window renders incorrectly, failing to fill the width of the right panel (see attached). The only way to solve this is to restart MM.

rusty

2018-04-24 20:56

administrator  

rusty

2018-04-24 20:56

administrator  

14006_issue_9_NP.jpg (50,505 bytes)
14006_issue_9_NP.jpg (50,505 bytes)

petr

2018-04-25 22:00

developer   ~0050116

Fixed

rusty

2018-04-30 23:46

administrator   ~0050144

Verified 2102.